#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include "testlib.h"

using namespace std;

vector<string> lex;
string password;

int myrandom(int i) {
	return rnd.next(i);
}

void genwords(int k, int tp) {
	if (tp == 0) {
		for (int i = 0; i < k; i++) {
			string w = rnd.next("[a-z]{1,10}");
			lex.push_back(w);
		}
	} else if (tp == 1) {
		string w = rnd.next("[a-z]{1,10}");
		for (int i = 0; i < k; i++) {
			lex.push_back(w);
			for (size_t q = 0; q < w.size(); q++) {
				int coin = rnd.next(5);
				if (!coin) {
					string ch = rnd.next("[a-z]{1,1}");
					lex[i][q] = ch[0];
				}
			}
		}
	} else if (tp == 2) {
		string w = rnd.next("[a-z]{1,1}");
		lex.push_back(w);
		for (int i = 1; i < k; i++) {
			lex.push_back(lex[i - 1] + w);
		}
	} else {
		string w = rnd.next("[a-z]{1,5}");
		string u = rnd.next("[a-z]{1,5}");
		lex.push_back(w);
		lex.push_back(u);
		lex.push_back(w + u);
	}
	random_shuffle(lex.begin(), lex.end(), myrandom);
}

void genpass(int n) {
	password = "";
	int q = 0;
	while (true) {
		int p = rnd.next((int)lex.size());
		if ((int)password.size() + (int)lex[p].size() > n) {
			q++;
			if (q > 10) {
				return;
			}
		} else {
			password += lex[p];
		}
	}
}

void randpass(int l) {
	
	for (size_t i = 0; i < password.size(); i++) {
		int coin = rnd.next(l);
		if (!coin) {
			password[i] = '*';
		}
	}
	
}

int main(int argc, char * argv[]) {
	
	
	registerGen(argc, argv);
	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	int l = atoi(argv[3]);
	int tp = atoi(argv[4]);
	
	genwords(k, tp);
	genpass(n);
	randpass(l);
	cout << password.size() << " " << lex.size() << endl;
	cout << password << endl;
	for (size_t i = 0; i < lex.size(); i++) {
		cout << lex[i] << endl;
	}
	
	return 0;
}
