#include "testlib.h"
#include <vector>
#include <string>
using namespace std;
vector<string> pans;
bool used[105][105];
int n,m;
int go[4][2] = {{0,1},{0,-1},{1,0},{-1,0}};
int dfs(int i, int j)
{
	int ans = 1;
	used[i][j] = true;
	for (int k = 0; k < 4; k++)
	{
		int ni = i + go[k][0];
		int nj = j + go[k][1];
		if (ni < 0 || ni >= n || nj < 0 || nj >= m) continue;
		if (pans[i][j] == pans[ni][nj] && !used[ni][nj]) ans += dfs(ni,nj);
	}

	return ans;
}



int main(int argc, char * argv[])
{
    setName("check correct solution");
    registerTestlibCmd(argc, argv);
    
    n = inf.readInt();
	inf.readSpace();
	m = inf.readInt();
	string jury = ans.readWord();
	pans.resize(n);
        
	pans[0] = ouf.readWord();
	if (jury == "impossible" && pans[0] == "impossible")
		quitf(_ok, "it is impossible");
        if (pans[0].length() != m) quitf(_wa, "length of line 1 not equal to m");

	for (int i = 1; i < n; i++)
		{pans[i] = ouf.readWord(); if (pans[i].length() != m) quitf(_wa, "length of line %d not equal to m",i+1);}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
                 { if (pans[i][j] < 'A' || pans[i][j] > 'Z') quitf(_wa, "char %c not in range [A..Z]", pans[i][j]);
			used[i][j] = false;
                 }

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
            
			if (!used[i][j])
			{
				int cnt = dfs(i,j);
				if (cnt < 2 || cnt > 3)
					quitf(_wa,"in line %d, char %d figure contains %d cells", i+1, j+1, cnt);
			}


	
	for (int i = 0; i < n-1; i++)
	{
		bool flag = true;
		for (int j = 0; j < m && flag; j++)
			if (pans[i][j] == pans[i+1][j]) flag = false;
		if (flag) quitf(_wa, "there is horisontal line under line %d", i+1);
	}

	for (int i = 0; i < m-1; i++)
	{
		bool flag = true;
		for (int j = 0; j < n && flag; j++)
			if (pans[j][i] == pans[j][i+1]) flag = false;
		if (flag) quitf(_wa, "there is vertical line in the right of column %d", i+1);
	}	
   
    
    quitf(_ok, "good job");
}
